package pr_x;

import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import java.sql.*;

public class X04_JDBCFrame extends JFrame {
  static ResultSet rs;

  //static String  driver="com.imaginary.sql.msql.MsqlDriver";
  static String  driver="org.gjt.mm.mysql.Driver";
  static String  database="jdbc:mysql://localhost:3306/A";
  static DB db;
  static final String[] hints={
     "org.gjt.mm.mysql.Driver    ~    jdbc:mysql://localhost:3306/A",
     "com.imaginary.sql.msql.MsqlDriver    ~   jdbc:msql://localhost:1112/AA",
     "SELECT   *  FROM table",
     "SELECT   *  FROM table WHERE (cond) ",
     "INSERT INTO  table  (col) VALUES  ('val')",
     "INSERT INTO  table  (col1, col2) VALUES  ('val1', 'val2')",
     "CREATE TABLE table (col char(10))",
     "CREATE TABLE table (col1 char(10), col2 char(10))"
  };


  JPanel panx = new JPanel();
  GridLayout gridLayout1 = new GridLayout();

  JPanel pan1 =    new JPanel();
  JLabel lab1 =    new JLabel("JDBC DRIVER",SwingConstants.RIGHT);
  JTextField tf1 = new JTextField(driver);

  JPanel pan2 =    new JPanel();
  JLabel lab2 =    new JLabel("DATABASE",SwingConstants.RIGHT);
  JTextField tf2 = new JTextField(database);


  JPanel pan3 =    new JPanel();
  JLabel lab3 =    new JLabel("COMMAND");
  JTextField tf3 = new JTextField(hints[7]);

  JPanel pan4 =    new JPanel();
  JLabel lab4 =    new JLabel("COMMAND");
  JTextField tf4 = new JTextField(hints[5]);

  JPanel pan5 =    new JPanel();
  JLabel lab5 =    new JLabel("COMMAND");
  JTextField tf5 = new JTextField(hints[3]);

  BorderLayout borderLayout1 = new BorderLayout();

  static JTextArea ta = new JTextArea("Result set");


  public X04_JDBCFrame() {
    try {jbInit(); }
    catch(Exception e) {e.printStackTrace();}
     setSize(800,300);
     setVisible(true);

     JFrame h=new JFrame("Hints");
     JTextArea th=new JTextArea(hints[0],hints.length,40);

     for (int i=1; i<hints.length; i++) th.append("\n"+hints[i]);

     h.getContentPane().add(th);
     h.setLocation(100,100);
     h.pack();
     h.setVisible(true);



  }

  public static void main(String[] args) throws Exception {
    X04_JDBCFrame fr= new X04_JDBCFrame();
    System.out.println("before db ");
   // db=new DB("XXX");  System.out.println("db="+db);
   // ta.setText(db.toString());
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    panx.setLayout(new GridLayout(5,1));
    panx.setPreferredSize(new Dimension(500, 150));

    tf1.setPreferredSize(new Dimension(600, 30));
    tf1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
       // tf1_actionPerformed(e);
      }
    });

    pan2.setPreferredSize(new Dimension(500, 100));

    tf2.setPreferredSize(new Dimension(600, 30));
    tf2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
       // tf2_actionPerformed(e);
      }
    });

    tf3.setPreferredSize(new Dimension(600, 30));
    tf3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        command(e);
      }
    });

    tf4.setPreferredSize(new Dimension(600, 30));
    tf4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        command(e);
      }
    });

    tf5.setPreferredSize(new Dimension(600, 30));
    tf5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        command(e);
      }
    });

    ta.setBackground(new Color(217, 243, 184));
    ta.setEditable(false);

    this.getContentPane().add(panx, BorderLayout.NORTH);
    pan1.add(lab1);
    pan1.add(tf1);

    pan2.add(lab2, null);
    pan2.add(tf2, null);

    pan3.add(lab3, null);
    pan3.add(tf3, null);

    pan4.add(lab4, null);
    pan4.add(tf4, null);

    pan5.add(lab5, null);
    pan5.add(tf5, null);


    panx.add(pan1, null);
    panx.add(pan2, null);
    panx.add(pan3, null);
    panx.add(pan4, null);
    panx.add(pan5, null);

    this.getContentPane().add(ta, BorderLayout.CENTER);

    System.out.println("Drivers");
    Enumeration k=DriverManager.getDrivers();
    while (k.hasMoreElements()) {
      System.out.println(k.nextElement());
    }
    System.out.println("Drivers end");
  }

  /**  */
  /*
  void tf1_actionPerformed(ActionEvent e) {
    try {

      System.out.println("Register a JDBC driver: "+tf1.getText());
      Class.forName(tf1.getText());


      System.out.println("Available drivers");
      Enumeration k=DriverManager.getDrivers();
      while (k.hasMoreElements()) {
        System.out.println(k.nextElement());
      }
      } catch (Exception ex) {ta.setText(ex.toString());}
  }
  */
  /**  */

  void command(ActionEvent e)  {
    String t=((JTextField) (e.getSource())).getText();
    Object x=db.perform(t);

     System.out.println("x="+x);

       int  i=0;
       ta.setText(t+"  "+x);

       if (x instanceof ResultSet) {
         try {
           ta.setText("RESULT SET:\n");
           ResultSet rs=(ResultSet)x;
           ResultSetMetaData rsmd= rs.getMetaData();
           int j=rsmd.getColumnCount();

           while(rs.next()) {
              i++;
              ta.append("\n "+i+"  ");
              for (int k = 1; k <=j; k++) {
                 ta.append(rs.getString(k)+", ");
              }
           }
          ta.setText(ta.getText()+"\nTOTAL="+i);
         } catch (Exception ex) { ta.append("\n"+ex);
           System.out.println("ex= "+ex);}
       }
  }
/*
  void tf2_actionPerformed(ActionEvent e) {
    try {
       db=new DB(tf2.getText());
    } catch (Exception ex) {ta.setText(ex.toString());}
  }
*/
}