package pr_x;

import javax.swing.*;
import javax.swing.table.*;

public class X05_JTable extends JFrame {

  static final String[] hints={
     "SELECT   *  FROM table",
     "SELECT   *  FROM table WHERE (cond) ",
     "INSERT INTO  table  (col) VALUES  ('val')",
     "INSERT INTO  table  (col1, col2) VALUES  ('val1', 'val2')",
     "CREATE table (col char(10))",
     "CREATE table (col1 char(10), col2 char(10)) VALUES ('val1', 'val2')"
  };

   TableModel dataModel = new AbstractTableModel() {
          public int getColumnCount() { return 3; }
          public int getRowCount() { return 5;}
          public Object getValueAt(int row, int col) { return new String("="+row*col); }
  };

  static TableModel def = new DefaultTableModel(hints.length,1);

  static { for (int i = 0; i <hints.length; i++) def.setValueAt(hints[i],i,0);

  }

 // JTable jt=new JTable(dataModel);
  JTable jt=new JTable(def);

  public X05_JTable() {
     this.setTitle("SQL hints");
     this.getContentPane().add(jt);
   //  this.setSize(300,300);
     this.pack();
     this.setVisible(true);
  }


  public static void main(String[] args) {
    X05_JTable x05_JTable1 = new X05_JTable();
  }
}